/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Tree-Interval-Fast.xs. Do not edit this file, edit Tree-Interval-Fast.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Tree-Interval-Fast.xs"
#ifdef __cplusplus
extern "C" {
#endif

/* 
   From http://blogs.perl.org/users/nick_wellnhofer/2015/03/writing-xs-like-a-pro---perl-no-get-context-and-static-functions.html
   The perlxs man page recommends to define the PERL_NO_GET_CONTEXT macro before including EXTERN.h, perl.h, and XSUB.h. 
   If this macro is defined, it is assumed that the interpreter context is passed as a parameter to every function. 
   If it's undefined, the context will typically be fetched from thread-local storage when calling the Perl API, which 
   incurs a performance overhead.
   
   WARNING:
   
    setting this macro involves additional changes to the XS code. For example, if the XS file has static functions that 
    call into the Perl API, you'll get somewhat cryptic error messages like the following:

    /usr/lib/i386-linux-gnu/perl/5.20/CORE/perl.h:155:16: error: ‘my_perl’ undeclared (first use in this function)
    #  define aTHX my_perl

   See http://perldoc.perl.org/perlguts.html#How-do-I-use-all-this-in-extensions? for ways in which to avoid these
   errors when using the macro.

   One way is to begin each static function that invoke the perl API with the dTHX macro to fetch context. This is
   used in the following static functions.
   Another more efficient approach is to prepend pTHX_ to the argument list in the declaration of each static
   function and aTHX_ when each of these functions are invoked. This is used directly in the AVL tree library
   source code.
*/
#define PERL_NO_GET_CONTEXT
  
#ifdef ENABLE_DEBUG
#define TRACEME(x) do {						\
    if (SvTRUE(perl_get_sv("Tree::Interval::Fast::ENABLE_DEBUG", TRUE)))	\
      { PerlIO_stdoutf (x); PerlIO_stdoutf ("\n"); }		\
  } while (0)
#else
#define TRACEME(x)
#endif
  
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
  
#include "ppport.h"
  
#include "interval.h"
#include "interval_list.h"
#include "interval_tree.h"

#ifdef __cplusplus
}
#endif

typedef interval_t* Tree__Interval__Fast__Interval;
typedef itree_t* Tree__Interval__Fast;

/* C-level callbacks required by the interval tree library */

static SV* svclone(SV* p) {
  dTHX;       /* fetch context */

  return SvREFCNT_inc(p);
}

void svdestroy(SV* p) {
  dTHX;       /* fetch context */

  SvREFCNT_dec(p);
}

/*====================================================================
 * XS SECTION                                                     
 *====================================================================*/

#line 85 "Tree-Interval-Fast.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 229 "Tree-Interval-Fast.c"

XS_EUPXS(XS_Tree__Interval__Fast__Interval_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tree__Interval__Fast__Interval_new)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "packname, low, high, data");
    {
	char*	packname = (char *)SvPV_nolen(ST(0))
;
	float	low = (float)SvNV(ST(1))
;
	float	high = (float)SvNV(ST(2))
;
	SV*	data = ST(3)
;
	Tree__Interval__Fast__Interval	RETVAL;
#line 85 "Tree-Interval-Fast.xs"
    RETVAL = interval_new(low, high, data, svclone, svdestroy);
#line 249 "Tree-Interval-Fast.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Tree::Interval::Fast::Interval", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tree__Interval__Fast__Interval_copy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tree__Interval__Fast__Interval_copy)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "interval");
    {
	Tree__Interval__Fast__Interval	interval;
	Tree__Interval__Fast__Interval	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tree::Interval::Fast::Interval")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    interval = INT2PTR(Tree__Interval__Fast__Interval,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Tree::Interval::Fast::Interval::copy",
			"interval", "Tree::Interval::Fast::Interval",
			refstr, ST(0)
		);
	}
;
#line 94 "Tree-Interval-Fast.xs"
    RETVAL = interval_copy(interval);
#line 286 "Tree-Interval-Fast.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Tree::Interval::Fast::Interval", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tree__Interval__Fast__Interval_overlap); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tree__Interval__Fast__Interval_overlap)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "i1, i2");
    {
	Tree__Interval__Fast__Interval	i1;
	Tree__Interval__Fast__Interval	i2;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tree::Interval::Fast::Interval")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    i1 = INT2PTR(Tree__Interval__Fast__Interval,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Tree::Interval::Fast::Interval::overlap",
			"i1", "Tree::Interval::Fast::Interval",
			refstr, ST(0)
		);
	}
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Tree::Interval::Fast::Interval")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    i2 = INT2PTR(Tree__Interval__Fast__Interval,tmp);
	}
	else {
		const char* refstr = SvROK(ST(1)) ? "" : SvOK(ST(1)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Tree::Interval::Fast::Interval::overlap",
			"i2", "Tree::Interval::Fast::Interval",
			refstr, ST(1)
		);
	}
;
#line 104 "Tree-Interval-Fast.xs"
    RETVAL = interval_overlap(i1, i2);
#line 339 "Tree-Interval-Fast.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tree__Interval__Fast__Interval_equal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tree__Interval__Fast__Interval_equal)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "i1, i2");
    {
	Tree__Interval__Fast__Interval	i1;
	Tree__Interval__Fast__Interval	i2;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tree::Interval::Fast::Interval")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    i1 = INT2PTR(Tree__Interval__Fast__Interval,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Tree::Interval::Fast::Interval::equal",
			"i1", "Tree::Interval::Fast::Interval",
			refstr, ST(0)
		);
	}
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Tree::Interval::Fast::Interval")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    i2 = INT2PTR(Tree__Interval__Fast__Interval,tmp);
	}
	else {
		const char* refstr = SvROK(ST(1)) ? "" : SvOK(ST(1)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Tree::Interval::Fast::Interval::equal",
			"i2", "Tree::Interval::Fast::Interval",
			refstr, ST(1)
		);
	}
;
#line 114 "Tree-Interval-Fast.xs"
    RETVAL = interval_equal(i1, i2);
#line 388 "Tree-Interval-Fast.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tree__Interval__Fast__Interval_low); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tree__Interval__Fast__Interval_low)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "interval");
    {
	Tree__Interval__Fast__Interval	interval;
	float	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tree::Interval::Fast::Interval")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    interval = INT2PTR(Tree__Interval__Fast__Interval,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Tree::Interval::Fast::Interval::low",
			"interval", "Tree::Interval::Fast::Interval",
			refstr, ST(0)
		);
	}
;
#line 123 "Tree-Interval-Fast.xs"
    RETVAL = interval->low;
#line 422 "Tree-Interval-Fast.c"
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tree__Interval__Fast__Interval_high); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tree__Interval__Fast__Interval_high)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "interval");
    {
	Tree__Interval__Fast__Interval	interval;
	float	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tree::Interval::Fast::Interval")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    interval = INT2PTR(Tree__Interval__Fast__Interval,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Tree::Interval::Fast::Interval::high",
			"interval", "Tree::Interval::Fast::Interval",
			refstr, ST(0)
		);
	}
;
#line 132 "Tree-Interval-Fast.xs"
    RETVAL = interval->high;
#line 456 "Tree-Interval-Fast.c"
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tree__Interval__Fast__Interval_data); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tree__Interval__Fast__Interval_data)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "interval");
    {
	Tree__Interval__Fast__Interval	interval;
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tree::Interval::Fast::Interval")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    interval = INT2PTR(Tree__Interval__Fast__Interval,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Tree::Interval::Fast::Interval::data",
			"interval", "Tree::Interval::Fast::Interval",
			refstr, ST(0)
		);
	}
;
#line 141 "Tree-Interval-Fast.xs"
    RETVAL = newSVsv(interval->data);
#line 489 "Tree-Interval-Fast.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tree__Interval__Fast__Interval_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tree__Interval__Fast__Interval_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "interval");
    {
	Tree__Interval__Fast__Interval	interval;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    interval = INT2PTR(Tree__Interval__Fast__Interval,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Tree::Interval::Fast::Interval::DESTROY",
			"interval")
;
#line 150 "Tree-Interval-Fast.xs"
    interval_delete(interval);
#line 517 "Tree-Interval-Fast.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tree__Interval__Fast_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tree__Interval__Fast_new)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "class");
    {
	char*	class = (char *)SvPV_nolen(ST(0))
;
	Tree__Interval__Fast	RETVAL;
#line 160 "Tree-Interval-Fast.xs"
    TRACEME("Allocating interval tree");
    RETVAL = itree_new(svclone, svdestroy);

    if(RETVAL == NULL) {
      warn("Unable to allocate interval tree");
      XSRETURN_UNDEF;
    }

#line 542 "Tree-Interval-Fast.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Tree::Interval::Fast", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tree__Interval__Fast_find); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tree__Interval__Fast_find)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "tree, low, high");
    {
	Tree__Interval__Fast	tree;
	int	low = (int)SvIV(ST(1))
;
	int	high = (int)SvIV(ST(2))
;
#line 178 "Tree-Interval-Fast.xs"
    interval_t *i, *result;

#line 569 "Tree-Interval-Fast.c"
	Tree__Interval__Fast__Interval	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tree::Interval::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    tree = INT2PTR(Tree__Interval__Fast,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Tree::Interval::Fast::find",
			"tree", "Tree::Interval::Fast",
			refstr, ST(0)
		);
	}
;
#line 181 "Tree-Interval-Fast.xs"
    i = interval_new( low, high, &PL_sv_undef, svclone, svdestroy);

    result = itree_find( tree, i );
    interval_delete(i);

    if(result == NULL)
      XSRETURN_UNDEF;

    /*
     * Return a copy of the result as this belongs to the tree
     *
     * WARNING
     *
     * Invoking interval_copy on the result generates segfault.
     * Couldn't figure out why so far.
     *
     */
    RETVAL = interval_new( result->low, result->high, result->data, svclone, svdestroy);

#line 605 "Tree-Interval-Fast.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Tree::Interval::Fast::Interval", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tree__Interval__Fast_findall); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tree__Interval__Fast_findall)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "tree, low, high");
    {
	Tree__Interval__Fast	tree;
	int	low = (int)SvIV(ST(1))
;
	int	high = (int)SvIV(ST(2))
;
#line 210 "Tree-Interval-Fast.xs"
    AV* av_ref;
    interval_t *i;
    const interval_t *item;
    ilist_t* results;
    ilisttrav_t* trav;

#line 636 "Tree-Interval-Fast.c"
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tree::Interval::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    tree = INT2PTR(Tree__Interval__Fast,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Tree::Interval::Fast::findall",
			"tree", "Tree::Interval::Fast",
			refstr, ST(0)
		);
	}
;
#line 217 "Tree-Interval-Fast.xs"
    i = interval_new ( low, high, &PL_sv_undef, svclone, svdestroy );

    results = itree_findall ( tree, i );
    interval_delete ( i );

    /* empty results set, return undef */
    if ( results == NULL || !ilist_size ( results ) ) {
      ilist_delete ( results );
      XSRETURN_UNDEF;
    }

    /* return a reference to an array of intervals */
    av_ref = (AV*) sv_2mortal( (SV*) newAV() );

    trav = ilisttrav_new( results );
    if ( trav == NULL ) {
      ilist_delete ( results );
      croak("Cannot traverse results set");
    }

    for(item = ilisttrav_first(trav); item!=NULL; item=ilisttrav_next(trav)) {
      SV* ref = newSV(0);
      sv_setref_pv( ref, "Tree::Interval::Fast::Interval", (void*)interval_new(item->low, item->high, item->data, svclone, svdestroy) );
      av_push(av_ref, ref);
    }

    RETVAL = newRV( (SV*) av_ref );
    ilist_delete ( results );

#line 682 "Tree-Interval-Fast.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tree__Interval__Fast_insert); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tree__Interval__Fast_insert)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "tree, interval");
    {
	Tree__Interval__Fast	tree;
	Tree__Interval__Fast__Interval	interval;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tree::Interval::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    tree = INT2PTR(Tree__Interval__Fast,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Tree::Interval::Fast::insert",
			"tree", "Tree::Interval::Fast",
			refstr, ST(0)
		);
	}
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Tree::Interval::Fast::Interval")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    interval = INT2PTR(Tree__Interval__Fast__Interval,tmp);
	}
	else {
		const char* refstr = SvROK(ST(1)) ? "" : SvOK(ST(1)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Tree::Interval::Fast::insert",
			"interval", "Tree::Interval::Fast::Interval",
			refstr, ST(1)
		);
	}
;
#line 256 "Tree-Interval-Fast.xs"
    RETVAL = itree_insert( tree, interval );

#line 732 "Tree-Interval-Fast.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tree__Interval__Fast_remove); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tree__Interval__Fast_remove)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "tree, interval");
    {
	Tree__Interval__Fast	tree;
	Tree__Interval__Fast__Interval	interval;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tree::Interval::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    tree = INT2PTR(Tree__Interval__Fast,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Tree::Interval::Fast::remove",
			"tree", "Tree::Interval::Fast",
			refstr, ST(0)
		);
	}
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Tree::Interval::Fast::Interval")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    interval = INT2PTR(Tree__Interval__Fast__Interval,tmp);
	}
	else {
		const char* refstr = SvROK(ST(1)) ? "" : SvOK(ST(1)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Tree::Interval::Fast::remove",
			"interval", "Tree::Interval::Fast::Interval",
			refstr, ST(1)
		);
	}
;
#line 267 "Tree-Interval-Fast.xs"
    RETVAL = itree_remove( tree, interval );

#line 782 "Tree-Interval-Fast.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tree__Interval__Fast_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tree__Interval__Fast_size)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "tree");
    {
	Tree__Interval__Fast	tree;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tree::Interval::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    tree = INT2PTR(Tree__Interval__Fast,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Tree::Interval::Fast::size",
			"tree", "Tree::Interval::Fast",
			refstr, ST(0)
		);
	}
;
#line 277 "Tree-Interval-Fast.xs"
    RETVAL = itree_size( tree );

#line 817 "Tree-Interval-Fast.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tree__Interval__Fast_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tree__Interval__Fast_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "tree");
    {
	Tree__Interval__Fast	tree;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    tree = INT2PTR(Tree__Interval__Fast,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Tree::Interval::Fast::DESTROY",
			"tree")
;
#line 287 "Tree-Interval-Fast.xs"
      TRACEME("Deleting interval tree");
      itree_delete( tree );
#line 846 "Tree-Interval-Fast.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Tree__Interval__Fast); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Tree__Interval__Fast)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("Tree::Interval::Fast::Interval::new", XS_Tree__Interval__Fast__Interval_new, file, "$$$");
        (void)newXSproto_portable("Tree::Interval::Fast::Interval::copy", XS_Tree__Interval__Fast__Interval_copy, file, "$");
        (void)newXSproto_portable("Tree::Interval::Fast::Interval::overlap", XS_Tree__Interval__Fast__Interval_overlap, file, "$$");
        (void)newXSproto_portable("Tree::Interval::Fast::Interval::equal", XS_Tree__Interval__Fast__Interval_equal, file, "$$");
        (void)newXSproto_portable("Tree::Interval::Fast::Interval::low", XS_Tree__Interval__Fast__Interval_low, file, "$");
        (void)newXSproto_portable("Tree::Interval::Fast::Interval::high", XS_Tree__Interval__Fast__Interval_high, file, "$");
        (void)newXSproto_portable("Tree::Interval::Fast::Interval::data", XS_Tree__Interval__Fast__Interval_data, file, "$");
        (void)newXSproto_portable("Tree::Interval::Fast::Interval::DESTROY", XS_Tree__Interval__Fast__Interval_DESTROY, file, "$");
        (void)newXSproto_portable("Tree::Interval::Fast::new", XS_Tree__Interval__Fast_new, file, "$");
        (void)newXSproto_portable("Tree::Interval::Fast::find", XS_Tree__Interval__Fast_find, file, "$$$");
        (void)newXSproto_portable("Tree::Interval::Fast::findall", XS_Tree__Interval__Fast_findall, file, "$$$");
        (void)newXSproto_portable("Tree::Interval::Fast::insert", XS_Tree__Interval__Fast_insert, file, "$$");
        (void)newXSproto_portable("Tree::Interval::Fast::remove", XS_Tree__Interval__Fast_remove, file, "$$");
        (void)newXSproto_portable("Tree::Interval::Fast::size", XS_Tree__Interval__Fast_size, file, "$");
        (void)newXSproto_portable("Tree::Interval::Fast::DESTROY", XS_Tree__Interval__Fast_DESTROY, file, "$");
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
